import { world, BlockPermutation } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:push_0', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('md:inout');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'md:inout': newOpenState
            });

            if (selectedItem && (selectedItem.typeId === 'md:md_tool')) {
                block.setPermutation(newPermutation);
                block.dimension.playSound("dig.powder_snow", block.location);
                block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`);
            }
        }
    });
});