import { world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:push_1', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');

            if (equipment) {
                const selectedItem = equipment.getEquipment('Mainhand');
                if (selectedItem && selectedItem.typeId === 'md:md_tool') {
                    if (block.permutation) {
                        const currentState = block.permutation.getState('md:inout');
                        
                        if (currentState < 3) {
                            block.setPermutation(block.permutation.withState('md:inout', currentState + 1));
                        } else if (currentState === 3) {
                            block.setPermutation(block.permutation.withState('md:inout', 0));
                        }

                        block.dimension.playSound("dig.powder_snow", block.location);
                        block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`);
                    }
                }
            }
        }
    });
});
