import { world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:rotate', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('md:rotate');

            if (selectedItem && (selectedItem.typeId === 'md:md_tool')) {
                if (currentState < 2) {
                    block.setPermutation(block.permutation.withState('md:rotate', currentState + 1))
                }
                if (currentState === 2) {
                    block.setPermutation(block.permutation.withState('md:rotate', currentState - 2))
                }

                block.dimension.playSound("dig.powder_snow", block.location);
                block.dimension.runCommandAsync(`particle minecraft:cauldron_explosion_emitter ${block.location.x} ${block.location.y + 0.5} ${block.location.z}`);
            }
        }
    });
});