import { world, BlockPermutation } from '@minecraft/server';
// Fitur Duduk di kursi awal contoh
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('md:sit', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');

            // Spawn the entity
            const entity = block.dimension.spawnEntity('md:sit', { x: block.location.x + 0.5, y: block.location.y + 0.6, z: block.location.z + 0.5 });

            // Get block direction
            const direction = block.permutation.getState("minecraft:cardinal_direction");
            const { x, y, z } = entity.location;

            // Apply rotation to the entity based on the block direction
            switch (direction) {
                case 'north': 
                    entity.teleport(entity.location, { facingLocation: { x, y, z: z + 1 } });
                    break;
                case 'east': 
                    entity.teleport(entity.location, { facingLocation: { x: x - 1, y, z } });
                    break;
                case 'south': 
                    entity.teleport(entity.location, { facingLocation: { x, y, z: z - 1 } });
                    break;
                case 'west': 
                    entity.teleport(entity.location, { facingLocation: { x: x + 1, y, z } });
                    break;
                default:
                    // Handle unexpected direction values
                    console.warn(`Unexpected direction: ${direction}`);
            }
        }
    });
});
